Legrand / Raritan / Server Technology Xerus™ JSON-RPC API: pdumodel::Outlet Interface Reference

Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
pdumodel::Outlet Interface Reference

Outlet interface More...

Inheritance diagram for pdumodel::Outlet:

## Classes
struct | LedState
| Outlet LED state More...
struct | MetaData
| Outlet metadata More...
struct | PowerControlEvent
| Event: Power control was initiated. More...
struct | Sensors
| Outlet sensors More...
struct | ServiceModeChangedEvent
| Event: Service mode has been changed. More...
struct | Settings
| Outlet settings More...
struct | SettingsChangedEvent
| Event: Outlet settings have been changed. More...
struct | State
| Outlet state More...
struct | StateChangedEvent
| Event: Outlet state has changed. More...

## Public Types
enum | PowerState { PS_OFF , PS_ON }
| Outlet power state. More...
enum | StartupState { SS_ON , SS_OFF , SS_LASTKNOWN , SS_PDUDEF }
| Outlet power state on device startup More...

## Public Member Functions
MetaData | getMetaData ()
| Retrieve the outlet metadata.
Sensors | getSensors ()
| Get the outlet sensors.
State | getState ()
| Retrieve the outlet state.
int | setPowerState (in PowerState pstate)
| Switch the outlet.
int | cyclePowerState ()
| Power-cycle the outlet.
Settings | getSettings ()
| Retrieve the outlet settings.
int | setSettings (in Settings settings)
| Change the outlet settings.
void | getIOP (out Inlet i, out OverCurrentProtector o, out vector< Pole > p)
| Get inlet, overcurrent protector and poles.
Controller | getController ()
| Get the controller for this outlet.
Waveform | getInrushWaveform ()
| Get the voltage and current waveforms at the time of last switch on operation.
int | setServiceModeEnabled (in boolean enabled)
| Enable or disable service mode on this outlet.
int | unstick ()
| Trigger an attempt to un-stick sticking relay contacts.
Public Member Functions inherited from pdumodel::EDevice
vector< EDevice > | getParents ()
| Get the list of devices that provide energy to this device.
vector< EDevice > | getChildren ()
| Get the list of devices that are directly fed by this device.
Waveform | getWaveform ()
| Get the current voltage and current waveforms for this device.
Waveform | getPoleWaveform (in PowerLine line)
| Get the current voltage and current waveforms for a pole of this device.

## Public Attributes
constant int | ERR_OUTLET_NOT_SWITCHABLE = 1
| Outlet is not switchable.
constant int | ERR_LOAD_SHEDDING_ACTIVE = 2
| Load-shedding is enabled (deprecated)
constant int | ERR_OUTLET_DISABLED = 3
| Outlet is disabled.
constant int | ERR_OUTLET_NOT_OFF = 4
| Outlet is on or in power-cylce; unstick not possible.
constant int | ERR_RELAY_CONTROL_DISABLED = 5
| Relay control is disabled in PDU settings.
constant int | ERR_INVALID_PARAM = 1
| Invalid parameters.
constant int | ERR_OPERATION_UNSUPPORTED = 1
| Operation is not supported.

## Detailed Description

Outlet interface

Definition at line 30 of file Outlet.idl.

## Member Enumeration Documentation

## ◆ PowerState

enum pdumodel::Outlet::PowerState

Outlet power state.

Used both for switching and representing the current state

Enumerator
PS_OFF | Switch off / Power is off.
PS_ON | Switch on / Power is on.

Definition at line 56 of file Outlet.idl.

## ◆ StartupState

enum pdumodel::Outlet::StartupState

Outlet power state on device startup

Enumerator
SS_ON | Outlet will be switched on
SS_OFF | Outlet will be switched off
SS_LASTKNOWN | Last known power state will be restored.
SS_PDUDEF | Use default state as defined in PDU settings.

Definition at line 91 of file Outlet.idl.

## Member Function Documentation

## ◆ cyclePowerState()

int pdumodel::Outlet::cyclePowerState | ( |  | ) |

Power-cycle the outlet.

Returns
  0 if OK
  1 if the outlet is not switchable
  3 if the outlet is disabled
  5 if relay control is disabled in the PDU settings

## ◆ getController()

Controller pdumodel::Outlet::getController | ( |  | ) |

Get the controller for this outlet.

Returns
  Sub controller reference

## ◆ getInrushWaveform()

Waveform pdumodel::Outlet::getInrushWaveform | ( |  | ) |

Get the voltage and current waveforms at the time of last switch on operation.

Note
  If waveform reading is not supported or a waveform could not be acquired for other reasons (e.g. the outlet not actually be switchable, or the outlet board being reset since the outlet was turned on), an empty waveform is returned.

Returns
  Waveform samples

## ◆ getIOP()

void pdumodel::Outlet::getIOP | ( | out Inlet | i,
|  | out OverCurrentProtector | o,
|  | out vector< Pole > | p
| ) |  |

Get inlet, overcurrent protector and poles.

Parameters

  i | Result: Inlet reference
  o | Result: Overcurrent protector reference
  p | Result: List of poles

## ◆ getMetaData()

MetaData pdumodel::Outlet::getMetaData | ( |  | ) |

Retrieve the outlet metadata.

Returns
  Outlet metadata

## ◆ getSensors()

Sensors pdumodel::Outlet::getSensors | ( |  | ) |

Get the outlet sensors.

Returns
  Outlet sensors

## ◆ getSettings()

Settings pdumodel::Outlet::getSettings | ( |  | ) |

Retrieve the outlet settings.

Returns
  Outlet settings

## ◆ getState()

State pdumodel::Outlet::getState | ( |  | ) |

Retrieve the outlet state.

Returns
  Outlet state

## ◆ setPowerState()

int pdumodel::Outlet::setPowerState | ( | in PowerState | pstate | ) |

Switch the outlet.

Parameters

  pstate | New power state

Returns
  0 if OK
  1 if the outlet is not switchable
  3 if the outlet is disabled
  5 if relay control is disabled in the PDU settings

## ◆ setServiceModeEnabled()

int pdumodel::Outlet::setServiceModeEnabled | ( | in boolean | enabled | ) |

Enable or disable service mode on this outlet.

If service mode is enabled, the outlet LED blinks in a specific pattern to indicate the enabled service mode when looking at the PDU (e.g. for technicians working on that outlet). In addition to that, sensors belonging to the outlet won't cause alarm events while the service mode is active.

Returns
  0 if OK
  1 if service mode is not supported on this outlet

## ◆ setSettings()

int pdumodel::Outlet::setSettings | ( | in Settings | settings | ) |

Change the outlet settings.

Parameters

  settings | New outlet settings

Returns
  0 if OK
  1 if any parameters are invalid

## ◆ unstick()

int pdumodel::Outlet::unstick | ( |  | ) |

Trigger an attempt to un-stick sticking relay contacts.

Warning: Please contact Tech Support before using this.

Tries repairing relay contacts that are sticked together due to wear by switching the relay in a certain pattern. Prior to running this method, the outlet must be in 'off' state to acknowledge that loads were disconnected.

Returns
  0 if unsticking was triggered successfully
  1 if outlet is not switchable
  3 if the outlet is disabled
  4 if relay is in a power cycle or on

## Member Data Documentation

## ◆ ERR_INVALID_PARAM

constant int pdumodel::Outlet::ERR_INVALID_PARAM = 1

Invalid parameters.

Definition at line 38 of file Outlet.idl.

## ◆ ERR_LOAD_SHEDDING_ACTIVE

constant int pdumodel::Outlet::ERR_LOAD_SHEDDING_ACTIVE = 2

Load-shedding is enabled (deprecated)

Definition at line 33 of file Outlet.idl.

## ◆ ERR_OPERATION_UNSUPPORTED

constant int pdumodel::Outlet::ERR_OPERATION_UNSUPPORTED = 1

Operation is not supported.

Definition at line 40 of file Outlet.idl.

## ◆ ERR_OUTLET_DISABLED

constant int pdumodel::Outlet::ERR_OUTLET_DISABLED = 3

Outlet is disabled.

Definition at line 34 of file Outlet.idl.

## ◆ ERR_OUTLET_NOT_OFF

constant int pdumodel::Outlet::ERR_OUTLET_NOT_OFF = 4

Outlet is on or in power-cylce; unstick not possible.

Definition at line 35 of file Outlet.idl.

## ◆ ERR_OUTLET_NOT_SWITCHABLE

constant int pdumodel::Outlet::ERR_OUTLET_NOT_SWITCHABLE = 1

Outlet is not switchable.

Definition at line 32 of file Outlet.idl.

## ◆ ERR_RELAY_CONTROL_DISABLED

constant int pdumodel::Outlet::ERR_RELAY_CONTROL_DISABLED = 5

Relay control is disabled in PDU settings.

Definition at line 36 of file Outlet.idl.

The documentation for this interface was generated from the following file:

- Outlet.idl